package com.simuwang.daq.utils;

import cn.hutool.core.collection.ListUtil;
import com.alibaba.excel.EasyExcel;
import com.alibaba.excel.read.builder.ExcelReaderBuilder;
import com.simuwang.base.pojo.dto.report.CustomExcelTable;
import com.simuwang.base.pojo.dto.report.SimpleTable;
import com.simuwang.daq.components.CustomExcelMultiSheetListener;

import java.util.List;

public class ExcelReportParseUtil {
    public static final String filepath = "D:\\Documents\\workspace\\idea\\smppw\\data-daq\\service-daq\\src\\main\\java\\com\\simuwang\\daq\\utils\\SEW698_旭日盛德价值成长一期私募证券投资基金_2023年第4季度报告.xlsx";

    public static void main(String[] args) {
        List<CustomExcelTable> customExcelTables = ListUtil.list(true);
        customExcelTables.add(new CustomExcelTable("fundInfo", "基金基本情况", 2));
        customExcelTables.add(new CustomExcelTable("financialIndicators", "主要财务指标", 5, 6));
        customExcelTables.add(new CustomExcelTable("financialIndicators", "级基金主要财务指标", 5, 6));
        customExcelTables.add(new CustomExcelTable("assetAllocation", "期末基金资产组合情况", 3));
        customExcelTables.add(new CustomExcelTable("investmentIndustry", "报告期末按行业分类的股票投资组合", 4));
        customExcelTables.add(new CustomExcelTable("investmentIndustry", "报告期末按行业分类的港股通投资股票投资组合", 3));
        customExcelTables.add(new CustomExcelTable("shareChange", "基金份额变动情况", 3, 6));
        customExcelTables.add(new CustomExcelTable("shareChange", "级基金份额变动情况", 3, 6));

        CustomExcelMultiSheetListener readListener = new CustomExcelMultiSheetListener();
        ExcelReaderBuilder readerBuilder = EasyExcel.read(filepath);
        readerBuilder.sheet();
        readerBuilder.customObject(customExcelTables);
        readerBuilder.registerReadListener(readListener);
        readerBuilder.doReadAll();

        List<SimpleTable> tables = readListener.getTables();
        for (SimpleTable table : tables) {
            System.out.println(table);
        }
    }
}
